<template>
  <div class="w-full" v-click-outside="close">
    <div>
      <input
        v-model="value"
        @keyup="search"
        :placeholder="placeholder"
        class="
          py-2
          px-16
          pl-3
          rounded-md
          focus:outline-none
          border border-solid border-gray-200
          focus:border-blue-400
        "
        type="text"
      />
    </div>
    <div class="relative w-64" v-if="isOpen">
      <ul class="absolute w-full bg-gray-200">
        <li
          v-for="item in items"
          :key="item.id"
          class="p-4 hover:bg-gray-300 cursor-pointer"
        >
          <router-link :to="{ name: 'edit', params: { id: item.id } }">{{
            item.title
          }}</router-link>
        </li>
      </ul>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import { Component, Prop } from "vue-property-decorator";

@Component({
  directives: {
    "click-outside": {
      bind: function (el: any, binding: any) {
        const clickEventHandler = (event: any) => {
          if (!el.contains(event.target) && el !== event.target) {
            binding.value(event);
          }
        };
        el.eventHandler = clickEventHandler;
        document.addEventListener("click", clickEventHandler);
      },
      unbind: function (el: any) {
        document.removeEventListener("click", el.eventHandler);
      },
    },
  },
})
export default class SearchBar extends Vue {
  @Prop({ default: "Search for something..." })
  private readonly placeholder!: string;
  @Prop({ default: () => [] }) private readonly items!: any;
  private value = "";
  private isOpen = false;
  private timer: any = null;
  private debounce = 300;

  private search(): void {
    if (this.value.trim().length > 0) {
      if (this.timer) clearTimeout(this.timer);
      this.timer = setTimeout((): void => {
        this.isOpen = true;
        this.$emit("search", this.value.trim());
      }, this.debounce);
    }
  }

  private close() {
    this.value = "";
    this.timer = null;
    this.isOpen = false;
  }
}
</script>
